// -*- C++ -*-
/*!
 * @file ManagerActionListener.h
 * @brief component action listener class
 * @date $Date$
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2011
 *     Noriaki Ando
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id$
 *
 */

#ifndef RTM_MANAGERACTIONLISTENER_H
#define RTM_MANAGERACTIONLISTENER_H

#include <vector>
#include <utility>
#include <coil/Mutex.h>
#include <coil/Guard.h>
#include <coil/Properties.h>
#include <coil/stringutil.h>
#include <rtm/ListenerHolder.h>

// forward decl
namespace RTC
{
  class RTObject_impl;
};

namespace RTM
{
  // forward decl
  class LocalServiceBase;
  
  //============================================================
  /*!
   * @if jp
   * @class ManagerActionListener
   *
   * - ޥ͡Shutdownľ: void onPreShutdown()
   * - ޥ͡Shutdownľ: void onPostShutdown()
   * - ޥ͡κƽľ: void onPreReinit()
   * - ޥ͡κƽľ: void onPostReinit()
   *
   * TODO: Documentation
   *
   * @else
   * @class ManagerActionListener
   *
   * TODO: Documentation
   *
   * @endif
   */
  class ManagerActionListener
  {
  public:
    /*!
     * @if jp
     * @brief ManagerActinListener dtor
     * TODO: Documentation
     * @else
     * @brief ManagerActionListener dtor
     * TODO: Documentation
     * @endif
     */
    virtual ~ManagerActionListener();

    /*!
     * @if jp
     * @brief preShutdown Хåؿ
     * TODO: Documentation
     * @else
     * @brief preShutdown callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preShutdown() = 0;

    /*!
     * @if jp
     * @brief postShutdown Хåؿ
     * TODO: Documentation
     * @else
     * @brief postShutdown callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postShutdown() = 0;

    /*!
     * @if jp
     * @brief preReinit Хåؿ
     * TODO: Documentation
     * @else
     * @brief preReinit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preReinit() = 0;

    /*!
     * @if jp
     * @brief postReinit Хåؿ
     * TODO: Documentation
     * @else
     * @brief postReinit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postReinit() = 0;
  };
  
  
  /*!
   * @if jp
   * @class ManagerActionListenerHolder 饹
   * @else
   * @class ManagerActionListenerHolder class
   * @endif
   */
  class ManagerActionListenerHolder
    : public ::RTM::util::ListenerHolder<ManagerActionListener>
  {
  public:
    virtual ~ManagerActionListenerHolder();

    /*!
     * @if jp
     * @brief preShutdown Хåؿ
     * TODO: Documentation
     * @else
     * @brief preShutdown callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preShutdown();

    /*!
     * @if jp
     * @brief postShutdown Хåؿ
     * TODO: Documentation
     * @else
     * @brief postShutdown callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postShutdown();

    /*!
     * @if jp
     * @brief preReinit Хåؿ
     * TODO: Documentation
     * @else
     * @brief preReinit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preReinit();

    /*!
     * @if jp
     * @brief postReinit Хåؿ
     * TODO: Documentation
     * @else
     * @brief postReinit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postReinit();
  };
  
  
  //============================================================
  /*!
   * @if jp
   * @class ModuleActionListener 饹
   * @brief ModuleActionListener 饹
   *
   * @else
   * @class ModuleActionListener class
   * @brief ModuleActionListener class
   *
   * @endif
   */
  class ModuleActionListener
  {
  public:
    /*!
     * @if jp
     * @brief ǥȥ饯
     * @else
     * @brief Destructor
     * @endif
     */
    virtual ~ModuleActionListener();
    
    /*!
     * @if jp
     * @brief preLoad Хåؿ
     * TODO: Documentation
     * @else
     * @brief preLoad callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preLoad(std::string& modname,
                         std::string& funcname) = 0;
    
    /*!
     * @if jp
     * @brief postLoad Хåؿ
     * TODO: Documentation
     * @else
     * @brief postLoad callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postLoad(std::string& modname,
                          std::string& funcname) = 0;
    
    /*!
     * @if jp
     * @brief preUnload Хåؿ
     * TODO: Documentation
     * @else
     * @brief preUnload callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preUnload(std::string& modname) = 0;
    
    /*!
     * @if jp
     * @brief postUnload Хåؿ
     * TODO: Documentation
     * @else
     * @brief postUnload callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postUnload(std::string& modname) = 0;
  };
  
  
  /*!
   * @if jp
   * @class ModuleActionListenerHolder 饹
   * @brief ModuleActionListenerHolder 饹
   *
   * @else
   * @class ModuleActionListenerHolder class
   * @brief ModuleActionListenerHolder class
   *
   * @endif
   */
  class ModuleActionListenerHolder
    : public ::RTM::util::ListenerHolder<ModuleActionListener>
  {
  public:
    /*!
     * @if jp
     * @brief ǥȥ饯
     * @else
     * @brief Destructor
     * @endif
     */
    virtual ~ModuleActionListenerHolder();
    
    /*!
     * @if jp
     * @brief preLoad Хåؿ
     * TODO: Documentation
     * @else
     * @brief preLoad callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preLoad(std::string& modname,
                         std::string& funcname);
    
    /*!
     * @if jp
     * @brief postLoad Хåؿ
     * TODO: Documentation
     * @else
     * @brief postLoad callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postLoad(std::string& modname,
                          std::string& funcname);
    
    /*!
     * @if jp
     * @brief preUnload Хåؿ
     * TODO: Documentation
     * @else
     * @brief preUnload callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preUnload(std::string& modname);
    
    /*!
     * @if jp
     * @brief postUnload Хåؿ
     * TODO: Documentation
     * @else
     * @brief postUnload callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postUnload(std::string& modname);
  };
  
  
  
  //============================================================
  /*!
   * @if jp
   * @class RtcLifecycleActionListener 饹
   * @brief RtcLifecycleActionListener 饹
   *
   * RTC
   * - RTCľ bool (std::string&)
   *   void preCreate(std::string& args) = 0;
   * - RTCľ bool (RTObject_impl*)
   *   void postCreate(RTObject_impl*) = 0;
   * - RTCΥեľ bool (coil::Properties& prop)
   *   void preConfigure(coil::Properties& prop) = 0;
   * - RTCΥեľ bool (coil::Properties& prop)
   *   void postConfigure(coil::Properties& prop) = 0;
   * - RTCνľ bool (void)
   *   void preInitialize(void) = 0;
   * - RTCνľ bool (void)
   *   void postInitialize(void) = 0;
   *
   * @else
   * @class RtcLifecycleActionListener class
   * @brief RtcLifecycleActionListener class
   *
   * This class is abstract base class for listener classes that
   * provides callbacks for various events in rtobject.
   *
   * @endif
   */
  class RtcLifecycleActionListener
  {
  public:
    /*!
     * @if jp
     * @brief ǥȥ饯
     * @else
     * @brief Destructor
     * @endif
     */
    virtual ~RtcLifecycleActionListener();
    
    /*!
     * @if jp
     * @brief preCreate Хåؿ
     * TODO: Documentation
     * @else
     * @brief preCreate callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preCreate(std::string& args) = 0;
    
    /*!
     * @if jp
     * @brief postCreate Хåؿ
     * TODO: Documentation
     * @else
     * @brief postCreate callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postCreate(RTC::RTObject_impl*) = 0;
    
    /*!
     * @if jp
     * @brief preConfigure Хåؿ
     * TODO: Documentation
     * @else
     * @brief preConfigure callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preConfigure(coil::Properties& prop) = 0;
    
    /*!
     * @if jp
     * @brief postConfigure Хåؿ
     * TODO: Documentation
     * @else
     * @brief postConfigure callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postConfigure(coil::Properties& prop) = 0;
    
    /*!
     * @if jp
     * @brief preInitialize Хåؿ
     * TODO: Documentation
     * @else
     * @brief preInitialize callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preInitialize(void) = 0;
    
    /*!
     * @if jp
     * @brief postInitialize Хåؿ
     * TODO: Documentation
     * @else
     * @brief postInitialize callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postInitialize(void) = 0;
  };
  
  
  /*!
   * @if jp
   * @class RtcLifecycleActionListenerHolder 饹
   * @brief RtcLifecycleActionListenerHolder 饹
   *
   * @else
   * @class RtcLifecycleActionListenerHolder class
   * @brief RtcLifecycleActionListenerHolder class
   *
   * This class is abstract base class for listener classes that
   * provides callbacks for various events in rtobject.
   *
   * @endif
   */
  class RtcLifecycleActionListenerHolder
    : public RTM::util::ListenerHolder<RtcLifecycleActionListener>
  {
  public:
    /*!
     * @if jp
     * @brief ǥȥ饯
     * @else
     * @brief Destructor
     * @endif
     */
    virtual ~RtcLifecycleActionListenerHolder();
    
    
    /*!
     * @if jp
     * @brief preCreate Хåؿ
     * TODO: Documentation
     * @else
     * @brief preCreate callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preCreate(std::string& args);
    
    /*!
     * @if jp
     * @brief postCreate Хåؿ
     * TODO: Documentation
     * @else
     * @brief postCreate callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postCreate(RTC::RTObject_impl* rtobj);
    
    /*!
     * @if jp
     * @brief preConfigure Хåؿ
     * TODO: Documentation
     * @else
     * @brief preConfigure callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preConfigure(coil::Properties& prop);
    
    /*!
     * @if jp
     * @brief postConfigure Хåؿ
     * TODO: Documentation
     * @else
     * @brief postConfigure callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postConfigure(coil::Properties& prop);
    
    /*!
     * @if jp
     * @brief preInitialize Хåؿ
     * TODO: Documentation
     * @else
     * @brief preInitialize callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preInitialize(void);
    
    /*!
     * @if jp
     * @brief postInitialize Хåؿ
     * TODO: Documentation
     * @else
     * @brief postInitialize callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postInitialize(void);
  };
  
  
  //============================================================
  /*!
   * @if jp
   * @class NamingActionListener 饹
   * @brief NamingActionListener 饹
   *
   * ƥб桼ɤƤФľΥߥ
   * ǥ뤵ꥹʥ饹δ쥯饹
   *
   * Registration
   * - PRE_NS_REGISTER:    RTC̾Ͽľ bool (coil::vstring&)
   * - POST_NS_REGISTER:   RTC̾Ͽľ bool (coil::vstring&)
   * - PRE_NS_UNREGISTER:  RTC̾Ͽľ bool (coil::vstring&)
   * - POST_NS_UNREGISTER: RTC̾Ͽľ bool (coil::vstring&)
   *
   * - ADD_PORT:
   * - REMOVE_PORT:
   *
   * @else
   * @class NamingActionListener class
   * @brief NamingActionListener class
   *
   * This class is abstract base class for listener classes that
   * provides callbacks for various events in rtobject.
   *
   * @endif
   */
  class NamingActionListener
  {
  public:
    /*!
     * @if jp
     * @brief ǥȥ饯
     * @else
     * @brief Destructor
     * @endif
     */
    virtual ~NamingActionListener();
    
    /*!
     * @if jp
     * @brief preBind Хåؿ
     * TODO: Documentation
     * @else
     * @brief preBind callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preBind(RTC::RTObject_impl* rtobj,
                         coil::vstring& name) = 0;
    /*!
     * @if jp
     * @brief postBind Хåؿ
     * TODO: Documentation
     * @else
     * @brief postBind callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postBind(RTC::RTObject_impl* rtobj,
                          coil::vstring& name) = 0;
    
    /*!
     * @if jp
     * @brief preUnbind Хåؿ
     * TODO: Documentation
     * @else
     * @brief preUnbind callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preUnbind(RTC::RTObject_impl* rtobj,
                           coil::vstring& name) = 0;
    
    /*!
     * @if jp
     * @brief postUnbind Хåؿ
     * TODO: Documentation
     * @else
     * @brief postUnbind callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postUnbind(RTC::RTObject_impl* rtobj,
                            coil::vstring& name) = 0;
  };
  
  
  /*!
   * @if jp
   * @class NamingActionListenerHolder 饹
   * @brief NamingActionListenerHolder 饹
   *
   * @else
   * @class NamingActionListenerHolder class
   * @brief NamingActionListenerHolder class
   *
   * This class is abstract base class for listener classes that
   * provides callbacks for various events in rtobject.
   *
   * @endif
   */
  class NamingActionListenerHolder
    : public RTM::util::ListenerHolder<NamingActionListener>
  {
  public:
    /*!
     * @if jp
     * @brief ǥȥ饯
     * @else
     * @brief Destructor
     * @endif
     */
    virtual ~NamingActionListenerHolder();
    
    /*!
     * @if jp
     * @brief preBind Хåؿ
     * TODO: Documentation
     * @else
     * @brief preBind callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preBind(RTC::RTObject_impl* rtobj,
                         coil::vstring& name);
    /*!
     * @if jp
     * @brief postBind Хåؿ
     * TODO: Documentation
     * @else
     * @brief postBind callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postBind(RTC::RTObject_impl* rtobj,
                          coil::vstring& name);
    
    /*!
     * @if jp
     * @brief preUnbind Хåؿ
     * TODO: Documentation
     * @else
     * @brief preUnbind callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preUnbind(RTC::RTObject_impl* rtobj,
                           coil::vstring& name);
    
    /*!
     * @if jp
     * @brief postUnbind Хåؿ
     * TODO: Documentation
     * @else
     * @brief postUnbind callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postUnbind(RTC::RTObject_impl* rtobj,
                            coil::vstring& name);
  };
  
  
  //============================================================
  /*!
   * @if jp
   * @class LocalServiceActionListener 饹
   * @brief LocalServiceActionListener 饹
   *
   * ƥб桼ɤƤФľΥߥ
   * ǥ뤵ꥹʥ饹δ쥯饹
   *
   * - ADD_PORT:
   * - REMOVE_PORT:
   *
   * @else
   * @class LocalServiceActionListener class
   * @brief LocalServiceActionListener class
   *
   * This class is abstract base class for listener classes that
   * provides callbacks for various events in rtobject.
   *
   * @endif
   */
  class LocalServiceActionListener
  {
  public:
    /*!
     * @if jp
     * @brief ǥȥ饯
     * @else
     * @brief Destructor
     * @endif
     */
    virtual ~LocalServiceActionListener();
    
    /*!
     * @if jp
     * @brief preServiceRegister Хåؿ
     * TODO: Documentation
     * @else
     * @brief preServiceRegister callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preServiceRegister(std::string service_name) = 0;
    
    /*!
     * @if jp
     * @brief postServiceRegister Хåؿ
     * TODO: Documentation
     * @else
     * @brief postServiceRegister callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postServiceRegister(std::string service_name,
                                     RTM::LocalServiceBase* service) = 0;

    /*!
     * @if jp
     * @brief preServiceInit Хåؿ
     * TODO: Documentation
     * @else
     * @brief preServiceInit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preServiceInit(coil::Properties& prop,
                                RTM::LocalServiceBase* service) = 0;
    
    /*!
     * @if jp
     * @brief postServiceInit Хåؿ
     * TODO: Documentation
     * @else
     * @brief postServiceInit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postServiceInit(coil::Properties& prop,
                                 RTM::LocalServiceBase* service) = 0;
    
    /*!
     * @if jp
     * @brief preServiceReinit Хåؿ
     * TODO: Documentation
     * @else
     * @brief preServiceReinit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preServiceReinit(coil::Properties& prop,
                                  RTM::LocalServiceBase* service) = 0;
    
    /*!
     * @if jp
     * @brief postServiceReinit Хåؿ
     * TODO: Documentation
     * @else
     * @brief postServiceReinit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postServiceReinit(coil::Properties& prop,
                                   RTM::LocalServiceBase* service) = 0;
    
    /*!
     * @if jp
     * @brief postServiceFinalize Хåؿ
     * TODO: Documentation
     * @else
     * @brief postServiceFinalize callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postServiceFinalize(std::string service_name,
                                     RTM::LocalServiceBase* service) = 0;
    
    /*!
     * @if jp
     * @brief preServiceFinalize Хåؿ
     * TODO: Documentation
     * @else
     * @brief preServiceFinalize callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preServiceFinalize(std::string service_name,
                                    RTM::LocalServiceBase* service) = 0;
  };
  
  
  /*!
   * @if jp
   * @class LocalServiceActionListenerHolder 饹
   * @brief LocalServiceActionListenerHolder 饹
   *
   * ƥб桼ɤƤФľΥߥ
   * ǥ뤵ꥹʥ饹δ쥯饹
   *
   * - ADD_PORT:
   * - REMOVE_PORT:
   *
   * @else
   * @class LocalServiceActionListenerHolder class
   * @brief LocalServiceActionListenerHolder class
   *
   * This class is abstract base class for listener classes that
   * provides callbacks for various events in rtobject.
   *
   * @endif
   */
  class LocalServiceActionListenerHolder
    : public RTM::util::ListenerHolder<LocalServiceActionListener>
  {
  public:
    /*!
     * @if jp
     * @brief ǥȥ饯
     * @else
     * @brief Destructor
     * @endif
     */
    virtual ~LocalServiceActionListenerHolder();
    
    // registration instance of service to svc admin
    /*!
     * @if jp
     * @brief preServiceRegister Хåؿ
     * TODO: Documentation
     * @else
     * @brief preServiceRegister callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preServiceRegister(std::string service_name);
    
    /*!
     * @if jp
     * @brief postServiceRegister Хåؿ
     * TODO: Documentation
     * @else
     * @brief postServiceRegister callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postServiceRegister(std::string service_name,
                                     RTM::LocalServiceBase* service);
    
    /*!
     * @if jp
     * @brief preServiceInit Хåؿ
     * TODO: Documentation
     * @else
     * @brief preServiceInit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preServiceInit(coil::Properties& prop,
                                RTM::LocalServiceBase* service);
    /*!
     * @if jp
     * @brief postServiceInit Хåؿ
     * TODO: Documentation
     * @else
     * @brief postServiceInit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postServiceInit(coil::Properties& prop,
                                 RTM::LocalServiceBase* service);
    
    /*!
     * @if jp
     * @brief preServiceReinit Хåؿ
     * TODO: Documentation
     * @else
     * @brief preServiceReinit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preServiceReinit(coil::Properties& prop,
                                  RTM::LocalServiceBase* service);
    /*!
     * @if jp
     * @brief postServiceReinit Хåؿ
     * TODO: Documentation
     * @else
     * @brief postServiceReinit callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postServiceReinit(coil::Properties& prop,
                                   RTM::LocalServiceBase* service);

    /*!
     * @if jp
     * @brief postServiceFinalize Хåؿ
     * TODO: Documentation
     * @else
     * @brief postServiceFinalize callback function
     * TODO: Documentation
     * @endif
     */
    virtual void postServiceFinalize(std::string service_name,
                                     RTM::LocalServiceBase* service);
    /*!
     * @if jp
     * @brief preServiceFinalize Хåؿ
     * TODO: Documentation
     * @else
     * @brief preServiceFinalize callback function
     * TODO: Documentation
     * @endif
     */
    virtual void preServiceFinalize(std::string service_name,
                                    RTM::LocalServiceBase* service);
  };
  
  
  
  /*!
   * @if jp
   * @class ManagerActionListeners
   * @brief ManagerActionListeners 饹
   *
   *
   * @else
   * @class ManagerActionListeners
   * @brief ManagerActionListeners class
   *
   *
   * @endif
   */
  class ManagerActionListeners
  {
  public:
    ManagerActionListenerHolder manager_;
    ModuleActionListenerHolder module_;
    RtcLifecycleActionListenerHolder rtclifecycle_;
    NamingActionListenerHolder naming_;
    LocalServiceActionListenerHolder localservice_;
  };
}; // namespace RTM

#endif // RTC_MANAGERACTIONLISTENER_H
